(function($) {
/*
 * Function to group consecutive widgets.
 */
function groupWidgets(type) {
  var group = [];
  $('.content-' + type).each( function() {
    var nextBox = $(this).next().hasClass('ui-' + type);
    group.push($(this));
    $(this).removeClass('ui-' + type).addClass(type + '-item');

    if (!nextBox) {
      var container = $('<div class="ui-' + type + '"></div>');
      container.insertBefore(group[0]);
      for (i = 0; i < group.length; i++) {
        group[i].appendTo(container);
      }
      group = [];
    }
  });
}

/*
 * Format accordion widgets to standard jQuery UI markup.
 */
Drupal.behaviors.ocioWysiwygAccordion = {
  attach: function(context, settings) {
    groupWidgets('accordion');
  }
};

/*
 * Format tabs widgets to standard jQuery UI markup.
 */
Drupal.behaviors.ocioWysiwygTabs = {
  attach: function(context, settings) {
    groupWidgets('tabs');

    $('.ui-tabs').each( function() {
      $(this).prepend('<ul class="ui-tabs-nav"></ul>');
      $(this).find('.content-tabs').each( function(i) {
        var id = 'ui-tabs-' + parseInt(i + 1);
        var header = $(this).find('div.ui-tabs-nav');

        $(this).parent().find('ul.ui-tabs-nav').append('<li><a href="#' + id +'">' + header.html() + '</a></li>');
        $(this).find('.ui-tabs-content').unwrap().attr("id", id);

        header.remove();
      });
    });
  }
};

}(jQuery));
